#ifndef KRITZEL_INKITEM_H
#define KRITZEL_INKITEM_H 1

#include <QtGui/QGraphicsItem>

namespace Kritzel
{

class Ink;
class Sample;

class InkItem : public QGraphicsItem
{
public:
    InkItem(QGraphicsItem *parent = 0);
    ~InkItem();

public:
    void setInk(const Ink &ink);
    Ink ink() const;
    void setPen(const QPen &pen);
    QPen pen() const;

    void beginStroke();
    void addSample(const Sample &sample);
    void endStroke();

public:
    virtual void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);
    virtual QRectF boundingRect() const;

private:
    class Private;
    Private * const d;
};

} // namespace Kritzel

#endif // KRITZEL_INKITEM_H
