#ifndef KRITZEL_NOTE_H
#define KRITZEL_NOTE_H 1

#include <QtGui/QWidget>

#include "ink.h"

namespace Kritzel
{

class Note : public QWidget
{
    Q_OBJECT

public:
    explicit Note(QWidget *parent = 0);
    ~Note();

public:
    QSize sizeHint() const;

protected:
    void enterEvent(QEvent *event);
    void leaveEvent(QEvent *event);

    void mousePressEvent(QMouseEvent *event);
    void mouseDoubleClickEvent(QMouseEvent *event);
    void mouseReleaseEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
    void tabletEvent(QTabletEvent *event);

    void paintEvent(QPaintEvent *pe);

private:
    bool eventFilter(QObject *watched, QEvent *event);

private:
    class Private;
    Private * const d;
};

};

#endif // KRITZEL_NOTE_H
