#ifndef KRITZEL_VIEW_H
#define KRITZEL_VIEW_H 1

#include <QtGui/QGraphicsView>

namespace Kritzel
{

class View : public QGraphicsView
{
    Q_OBJECT

public:
    explicit View(QWidget *parent = 0);
    ~View();

protected:
    void mousePressEvent(QMouseEvent *event);
    void mouseDoubleClickEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
    void mouseReleaseEvent(QMouseEvent *event);
    void tabletEvent(QTabletEvent *event);

    void drawBackground(QPainter *painter, const QRectF &rect);
    void drawForeground(QPainter *painter, const QRectF &rect);

private:
    class Private;
    Private * const d;
};

} // namespace Kritzel

#endif // KRITZEL_VIEW_H
